am --skip: revert changes introduced by failed 3way merge
[git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
4
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_STUCKLONG=t
8 OPTIONS_SPEC="\
9 git am [options] [(<mbox>|<Maildir>)...]
10 git am [options] (--continue | --skip | --abort)
11 --
12 i,interactive   run interactively
13 b,binary*       (historical option -- no-op)
14 3,3way          allow fall back on 3way merging if needed
15 q,quiet         be quiet
16 s,signoff       add a Signed-off-by line to the commit message
17 u,utf8          recode into utf8 (default)
18 k,keep          pass -k flag to git-mailinfo
19 keep-non-patch  pass -b flag to git-mailinfo
20 keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
21 no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
22 c,scissors      strip everything before a scissors line
23 whitespace=     pass it through git-apply
24 ignore-space-change pass it through git-apply
25 ignore-whitespace pass it through git-apply
26 directory=      pass it through git-apply
27 exclude=        pass it through git-apply
28 include=        pass it through git-apply
29 C=              pass it through git-apply
30 p=              pass it through git-apply
31 patch-format=   format the patch(es) are in
32 reject          pass it through git-apply
33 resolvemsg=     override error message when patch failure occurs
34 continue        continue applying patches after resolving a conflict
35 r,resolved      synonyms for --continue
36 skip            skip the current patch
37 abort           restore the original branch and abort the patching operation.
38 committer-date-is-author-date    lie about committer date
39 ignore-date     use current timestamp for author date
40 rerere-autoupdate update the index with reused conflict resolution if possible
41 S,gpg-sign?     GPG-sign commits
42 rebasing*       (internal use for git-rebase)"
43
44 . git-sh-setup
45 . git-sh-i18n
46 prefix=$(git rev-parse --show-prefix)
47 set_reflog_action am
48 require_work_tree
49 cd_to_toplevel
50
51 git var GIT_COMMITTER_IDENT >/dev/null ||
52         die "$(gettext "You need to set your committer info first")"
53
54 if git rev-parse --verify -q HEAD >/dev/null
55 then
56         HAS_HEAD=yes
57 else
58         HAS_HEAD=
59 fi
60
61 cmdline="git am"
62 if test '' != "$interactive"
63 then
64         cmdline="$cmdline -i"
65 fi
66 if test '' != "$threeway"
67 then
68         cmdline="$cmdline -3"
69 fi
70
71 empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
72
73 sq () {
74         git rev-parse --sq-quote "$@"
75 }
76
77 stop_here () {
78     echo "$1" >"$dotest/next"
79     git rev-parse --verify -q HEAD >"$dotest/abort-safety"
80     exit 1
81 }
82
83 safe_to_abort () {
84         if test -f "$dotest/dirtyindex"
85         then
86                 return 1
87         fi
88
89         if ! test -s "$dotest/abort-safety"
90         then
91                 return 0
92         fi
93
94         abort_safety=$(cat "$dotest/abort-safety")
95         if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
96         then
97                 return 0
98         fi
99         gettextln "You seem to have moved HEAD since the last 'am' failure.
100 Not rewinding to ORIG_HEAD" >&2
101         return 1
102 }
103
104 stop_here_user_resolve () {
105     if [ -n "$resolvemsg" ]; then
106             printf '%s\n' "$resolvemsg"
107             stop_here $1
108     fi
109     eval_gettextln "When you have resolved this problem, run \"\$cmdline --continue\".
110 If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
111 To restore the original branch and stop patching, run \"\$cmdline --abort\"."
112
113     stop_here $1
114 }
115
116 go_next () {
117         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
118                 "$dotest/patch" "$dotest/info"
119         echo "$next" >"$dotest/next"
120         this=$next
121 }
122
123 cannot_fallback () {
124         echo "$1"
125         gettextln "Cannot fall back to three-way merge."
126         exit 1
127 }
128
129 fall_back_3way () {
130     O_OBJECT=$(cd "$GIT_OBJECT_DIRECTORY" && pwd)
131
132     rm -fr "$dotest"/patch-merge-*
133     mkdir "$dotest/patch-merge-tmp-dir"
134
135     # First see if the patch records the index info that we can use.
136     cmd="git apply $git_apply_opt --build-fake-ancestor" &&
137     cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
138     eval "$cmd" &&
139     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
140     git write-tree >"$dotest/patch-merge-base+" ||
141     cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
142
143     say "$(gettext "Using index info to reconstruct a base tree...")"
144
145     cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
146
147     if test -z "$GIT_QUIET"
148     then
149         eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
150     fi
151
152     cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
153     if eval "$cmd"
154     then
155         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
156         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
157     else
158         cannot_fallback "$(gettext "Did you hand edit your patch?
159 It does not apply to blobs recorded in its index.")"
160     fi
161
162     test -f "$dotest/patch-merge-index" &&
163     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
164     orig_tree=$(cat "$dotest/patch-merge-base") &&
165     rm -fr "$dotest"/patch-merge-* || exit 1
166
167     say "$(gettext "Falling back to patching base and 3-way merge...")"
168
169     # This is not so wrong.  Depending on which base we picked,
170     # orig_tree may be wildly different from ours, but his_tree
171     # has the same set of wildly different changes in parts the
172     # patch did not touch, so recursive ends up canceling them,
173     # saying that we reverted all those changes.
174
175     eval GITHEAD_$his_tree='"$FIRSTLINE"'
176     export GITHEAD_$his_tree
177     if test -n "$GIT_QUIET"
178     then
179             GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
180     fi
181     git-merge-recursive $orig_tree -- HEAD $his_tree || {
182             git rerere $allow_rerere_autoupdate
183             die "$(gettext "Failed to merge in the changes.")"
184     }
185     unset GITHEAD_$his_tree
186 }
187
188 clean_abort () {
189         test $# = 0 || echo >&2 "$@"
190         rm -fr "$dotest"
191         exit 1
192 }
193
194 patch_format=
195
196 check_patch_format () {
197         # early return if patch_format was set from the command line
198         if test -n "$patch_format"
199         then
200                 return 0
201         fi
202
203         # we default to mbox format if input is from stdin and for
204         # directories
205         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
206         then
207                 patch_format=mbox
208                 return 0
209         fi
210
211         # otherwise, check the first few non-blank lines of the first
212         # patch to try to detect its format
213         {
214                 # Start from first line containing non-whitespace
215                 l1=
216                 while test -z "$l1"
217                 do
218                         read l1 || break
219                 done
220                 read l2
221                 read l3
222                 case "$l1" in
223                 "From "* | "From: "*)
224                         patch_format=mbox
225                         ;;
226                 '# This series applies on GIT commit'*)
227                         patch_format=stgit-series
228                         ;;
229                 "# HG changeset patch")
230                         patch_format=hg
231                         ;;
232                 *)
233                         # if the second line is empty and the third is
234                         # a From, Author or Date entry, this is very
235                         # likely an StGIT patch
236                         case "$l2,$l3" in
237                         ,"From: "* | ,"Author: "* | ,"Date: "*)
238                                 patch_format=stgit
239                                 ;;
240                         *)
241                                 ;;
242                         esac
243                         ;;
244                 esac
245                 if test -z "$patch_format" &&
246                         test -n "$l1" &&
247                         test -n "$l2" &&
248                         test -n "$l3"
249                 then
250                         # This begins with three non-empty lines.  Is this a
251                         # piece of e-mail a-la RFC2822?  Grab all the headers,
252                         # discarding the indented remainder of folded lines,
253                         # and see if it looks like that they all begin with the
254                         # header field names...
255                         tr -d '\015' <"$1" |
256                         sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
257                         sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
258                         patch_format=mbox
259                 fi
260         } < "$1" || clean_abort
261 }
262
263 split_patches () {
264         case "$patch_format" in
265         mbox)
266                 if test t = "$keepcr"
267                 then
268                     keep_cr=--keep-cr
269                 else
270                     keep_cr=
271                 fi
272                 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
273                 clean_abort
274                 ;;
275         stgit-series)
276                 if test $# -ne 1
277                 then
278                         clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
279                 fi
280                 series_dir=$(dirname "$1")
281                 series_file="$1"
282                 shift
283                 {
284                         set x
285                         while read filename
286                         do
287                                 set "$@" "$series_dir/$filename"
288                         done
289                         # remove the safety x
290                         shift
291                         # remove the arg coming from the first-line comment
292                         shift
293                 } < "$series_file" || clean_abort
294                 # set the patch format appropriately
295                 patch_format=stgit
296                 # now handle the actual StGIT patches
297                 split_patches "$@"
298                 ;;
299         stgit)
300                 this=0
301                 for stgit in "$@"
302                 do
303                         this=$(expr "$this" + 1)
304                         msgnum=$(printf "%0${prec}d" $this)
305                         # Perl version of StGIT parse_patch. The first nonemptyline
306                         # not starting with Author, From or Date is the
307                         # subject, and the body starts with the next nonempty
308                         # line not starting with Author, From or Date
309                         @@PERL@@ -ne 'BEGIN { $subject = 0 }
310                                 if ($subject > 1) { print ; }
311                                 elsif (/^\s+$/) { next ; }
312                                 elsif (/^Author:/) { s/Author/From/ ; print ;}
313                                 elsif (/^(From|Date)/) { print ; }
314                                 elsif ($subject) {
315                                         $subject = 2 ;
316                                         print "\n" ;
317                                         print ;
318                                 } else {
319                                         print "Subject: ", $_ ;
320                                         $subject = 1;
321                                 }
322                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
323                 done
324                 echo "$this" > "$dotest/last"
325                 this=
326                 msgnum=
327                 ;;
328         hg)
329                 this=0
330                 for hg in "$@"
331                 do
332                         this=$(( $this + 1 ))
333                         msgnum=$(printf "%0${prec}d" $this)
334                         # hg stores changeset metadata in #-commented lines preceding
335                         # the commit message and diff(s). The only metadata we care about
336                         # are the User and Date (Node ID and Parent are hashes which are
337                         # only relevant to the hg repository and thus not useful to us)
338                         # Since we cannot guarantee that the commit message is in
339                         # git-friendly format, we put no Subject: line and just consume
340                         # all of the message as the body
341                         LANG=C LC_ALL=C @@PERL@@ -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
342                                 if ($subject) { print ; }
343                                 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
344                                 elsif (/^\# Date /) {
345                                         my ($hashsign, $str, $time, $tz) = split ;
346                                         $tz = sprintf "%+05d", (0-$tz)/36;
347                                         print "Date: " .
348                                               strftime("%a, %d %b %Y %H:%M:%S ",
349                                                        localtime($time))
350                                               . "$tz\n";
351                                 } elsif (/^\# /) { next ; }
352                                 else {
353                                         print "\n", $_ ;
354                                         $subject = 1;
355                                 }
356                         ' <"$hg" >"$dotest/$msgnum" || clean_abort
357                 done
358                 echo "$this" >"$dotest/last"
359                 this=
360                 msgnum=
361                 ;;
362         *)
363                 if test -n "$patch_format"
364                 then
365                         clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
366                 else
367                         clean_abort "$(gettext "Patch format detection failed.")"
368                 fi
369                 ;;
370         esac
371 }
372
373 prec=4
374 dotest="$GIT_DIR/rebase-apply"
375 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
376 resolvemsg= resume= scissors= no_inbody_headers=
377 git_apply_opt=
378 committer_date_is_author_date=
379 ignore_date=
380 allow_rerere_autoupdate=
381 gpg_sign_opt=
382
383 if test "$(git config --bool --get am.keepcr)" = true
384 then
385     keepcr=t
386 fi
387
388 while test $# != 0
389 do
390         case "$1" in
391         -i|--interactive)
392                 interactive=t ;;
393         -b|--binary)
394                 gettextln >&2 "The -b/--binary option has been a no-op for long time, and
395 it will be removed. Please do not use it anymore."
396                 ;;
397         -3|--3way)
398                 threeway=t ;;
399         -s|--signoff)
400                 sign=t ;;
401         -u|--utf8)
402                 utf8=t ;; # this is now default
403         --no-utf8)
404                 utf8= ;;
405         -k|--keep)
406                 keep=t ;;
407         --keep-non-patch)
408                 keep=b ;;
409         -c|--scissors)
410                 scissors=t ;;
411         --no-scissors)
412                 scissors=f ;;
413         -r|--resolved|--continue)
414                 resolved=t ;;
415         --skip)
416                 skip=t ;;
417         --abort)
418                 abort=t ;;
419         --rebasing)
420                 rebasing=t threeway=t ;;
421         --resolvemsg=*)
422                 resolvemsg="${1#--resolvemsg=}" ;;
423         --whitespace=*|--directory=*|--exclude=*|--include=*)
424                 git_apply_opt="$git_apply_opt $(sq "$1")" ;;
425         -C*|-p*)
426                 git_apply_opt="$git_apply_opt $(sq "$1")" ;;
427         --patch-format=*)
428                 patch_format="${1#--patch-format=}" ;;
429         --reject|--ignore-whitespace|--ignore-space-change)
430                 git_apply_opt="$git_apply_opt $1" ;;
431         --committer-date-is-author-date)
432                 committer_date_is_author_date=t ;;
433         --ignore-date)
434                 ignore_date=t ;;
435         --rerere-autoupdate|--no-rerere-autoupdate)
436                 allow_rerere_autoupdate="$1" ;;
437         -q|--quiet)
438                 GIT_QUIET=t ;;
439         --keep-cr)
440                 keepcr=t ;;
441         --no-keep-cr)
442                 keepcr=f ;;
443         --gpg-sign)
444                 gpg_sign_opt=-S ;;
445         --gpg-sign=*)
446                 gpg_sign_opt="-S${1#--gpg-sign=}" ;;
447         --)
448                 shift; break ;;
449         *)
450                 usage ;;
451         esac
452         shift
453 done
454
455 # If the dotest directory exists, but we have finished applying all the
456 # patches in them, clear it out.
457 if test -d "$dotest" &&
458    test -f "$dotest/last" &&
459    test -f "$dotest/next" &&
460    last=$(cat "$dotest/last") &&
461    next=$(cat "$dotest/next") &&
462    test $# != 0 &&
463    test "$next" -gt "$last"
464 then
465    rm -fr "$dotest"
466 fi
467
468 if test -d "$dotest" && test -f "$dotest/last" && test -f "$dotest/next"
469 then
470         case "$#,$skip$resolved$abort" in
471         0,*t*)
472                 # Explicit resume command and we do not have file, so
473                 # we are happy.
474                 : ;;
475         0,)
476                 # No file input but without resume parameters; catch
477                 # user error to feed us a patch from standard input
478                 # when there is already $dotest.  This is somewhat
479                 # unreliable -- stdin could be /dev/null for example
480                 # and the caller did not intend to feed us a patch but
481                 # wanted to continue unattended.
482                 test -t 0
483                 ;;
484         *)
485                 false
486                 ;;
487         esac ||
488         die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
489         resume=yes
490
491         case "$skip,$abort" in
492         t,t)
493                 die "$(gettext "Please make up your mind. --skip or --abort?")"
494                 ;;
495         t,)
496                 git rerere clear
497                 head_tree=$(git rev-parse --verify -q HEAD || echo $empty_tree) &&
498                 git read-tree --reset -u $head_tree $head_tree &&
499                 index_tree=$(git write-tree) &&
500                 git read-tree -m -u $index_tree $head_tree
501                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
502                 git reset HEAD
503                 git update-ref ORIG_HEAD $orig_head
504                 ;;
505         ,t)
506                 if test -f "$dotest/rebasing"
507                 then
508                         exec git rebase --abort
509                 fi
510                 git rerere clear
511                 if safe_to_abort
512                 then
513                         git read-tree --reset -u HEAD ORIG_HEAD
514                         git reset ORIG_HEAD
515                 fi
516                 rm -fr "$dotest"
517                 exit ;;
518         esac
519         rm -f "$dotest/dirtyindex"
520 else
521         # Possible stray $dotest directory in the independent-run
522         # case; in the --rebasing case, it is upto the caller
523         # (git-rebase--am) to take care of stray directories.
524         if test -d "$dotest" && test -z "$rebasing"
525         then
526                 case "$skip,$resolved,$abort" in
527                 ,,t)
528                         rm -fr "$dotest"
529                         exit 0
530                         ;;
531                 *)
532                         die "$(eval_gettext "Stray \$dotest directory found.
533 Use \"git am --abort\" to remove it.")"
534                         ;;
535                 esac
536         fi
537
538         # Make sure we are not given --skip, --continue, or --abort
539         test "$skip$resolved$abort" = "" ||
540                 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
541
542         # Start afresh.
543         mkdir -p "$dotest" || exit
544
545         if test -n "$prefix" && test $# != 0
546         then
547                 first=t
548                 for arg
549                 do
550                         test -n "$first" && {
551                                 set x
552                                 first=
553                         }
554                         if is_absolute_path "$arg"
555                         then
556                                 set "$@" "$arg"
557                         else
558                                 set "$@" "$prefix$arg"
559                         fi
560                 done
561                 shift
562         fi
563
564         check_patch_format "$@"
565
566         split_patches "$@"
567
568         # -i can and must be given when resuming; everything
569         # else is kept
570         echo " $git_apply_opt" >"$dotest/apply-opt"
571         echo "$threeway" >"$dotest/threeway"
572         echo "$sign" >"$dotest/sign"
573         echo "$utf8" >"$dotest/utf8"
574         echo "$keep" >"$dotest/keep"
575         echo "$scissors" >"$dotest/scissors"
576         echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
577         echo "$GIT_QUIET" >"$dotest/quiet"
578         echo 1 >"$dotest/next"
579         if test -n "$rebasing"
580         then
581                 : >"$dotest/rebasing"
582         else
583                 : >"$dotest/applying"
584                 if test -n "$HAS_HEAD"
585                 then
586                         git update-ref ORIG_HEAD HEAD
587                 else
588                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
589                 fi
590         fi
591 fi
592
593 git update-index -q --refresh
594
595 case "$resolved" in
596 '')
597         case "$HAS_HEAD" in
598         '')
599                 files=$(git ls-files) ;;
600         ?*)
601                 files=$(git diff-index --cached --name-only HEAD --) ;;
602         esac || exit
603         if test "$files"
604         then
605                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
606                 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
607         fi
608 esac
609
610 # Now, decide what command line options we will give to the git
611 # commands we invoke, based on the result of parsing command line
612 # options and previous invocation state stored in $dotest/ files.
613
614 if test "$(cat "$dotest/utf8")" = t
615 then
616         utf8=-u
617 else
618         utf8=-n
619 fi
620 keep=$(cat "$dotest/keep")
621 case "$keep" in
622 t)
623         keep=-k ;;
624 b)
625         keep=-b ;;
626 *)
627         keep= ;;
628 esac
629 case "$(cat "$dotest/scissors")" in
630 t)
631         scissors=--scissors ;;
632 f)
633         scissors=--no-scissors ;;
634 esac
635 if test "$(cat "$dotest/no_inbody_headers")" = t
636 then
637         no_inbody_headers=--no-inbody-headers
638 else
639         no_inbody_headers=
640 fi
641 if test "$(cat "$dotest/quiet")" = t
642 then
643         GIT_QUIET=t
644 fi
645 if test "$(cat "$dotest/threeway")" = t
646 then
647         threeway=t
648 fi
649 git_apply_opt=$(cat "$dotest/apply-opt")
650 if test "$(cat "$dotest/sign")" = t
651 then
652         SIGNOFF=$(git var GIT_COMMITTER_IDENT | sed -e '
653                         s/>.*/>/
654                         s/^/Signed-off-by: /'
655                 )
656 else
657         SIGNOFF=
658 fi
659
660 last=$(cat "$dotest/last")
661 this=$(cat "$dotest/next")
662 if test "$skip" = t
663 then
664         this=$(expr "$this" + 1)
665         resume=
666 fi
667
668 while test "$this" -le "$last"
669 do
670         msgnum=$(printf "%0${prec}d" $this)
671         next=$(expr "$this" + 1)
672         test -f "$dotest/$msgnum" || {
673                 resume=
674                 go_next
675                 continue
676         }
677
678         # If we are not resuming, parse and extract the patch information
679         # into separate files:
680         #  - info records the authorship and title
681         #  - msg is the rest of commit log message
682         #  - patch is the patch body.
683         #
684         # When we are resuming, these files are either already prepared
685         # by the user, or the user can tell us to do so by --continue flag.
686         case "$resume" in
687         '')
688                 if test -f "$dotest/rebasing"
689                 then
690                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
691                                 -e q "$dotest/$msgnum") &&
692                         test "$(git cat-file -t "$commit")" = commit ||
693                                 stop_here $this
694                         git cat-file commit "$commit" |
695                         sed -e '1,/^$/d' >"$dotest/msg-clean"
696                         echo "$commit" >"$dotest/original-commit"
697                         get_author_ident_from_commit "$commit" >"$dotest/author-script"
698                         git diff-tree --root --binary --full-index "$commit" >"$dotest/patch"
699                 else
700                         git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
701                                 <"$dotest/$msgnum" >"$dotest/info" ||
702                                 stop_here $this
703
704                         # skip pine's internal folder data
705                         sane_grep '^Author: Mail System Internal Data$' \
706                                 <"$dotest"/info >/dev/null &&
707                                 go_next && continue
708
709                         test -s "$dotest/patch" || {
710                                 eval_gettextln "Patch is empty.  Was it split wrong?
711 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
712 To restore the original branch and stop patching run \"\$cmdline --abort\"."
713                                 stop_here $this
714                         }
715                         rm -f "$dotest/original-commit" "$dotest/author-script"
716                         {
717                                 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
718                                 echo
719                                 cat "$dotest/msg"
720                         } |
721                         git stripspace > "$dotest/msg-clean"
722                 fi
723                 ;;
724         esac
725
726         if test -f "$dotest/author-script"
727         then
728                 eval $(cat "$dotest/author-script")
729         else
730                 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
731                 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
732                 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
733         fi
734
735         if test -z "$GIT_AUTHOR_EMAIL"
736         then
737                 gettextln "Patch does not have a valid e-mail address."
738                 stop_here $this
739         fi
740
741         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
742
743         case "$resume" in
744         '')
745             if test '' != "$SIGNOFF"
746             then
747                 LAST_SIGNED_OFF_BY=$(
748                     sed -ne '/^Signed-off-by: /p' \
749                     "$dotest/msg-clean" |
750                     sed -ne '$p'
751                 )
752                 ADD_SIGNOFF=$(
753                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
754                     test '' = "$LAST_SIGNED_OFF_BY" && echo
755                     echo "$SIGNOFF"
756                 })
757             else
758                 ADD_SIGNOFF=
759             fi
760             {
761                 if test -s "$dotest/msg-clean"
762                 then
763                         cat "$dotest/msg-clean"
764                 fi
765                 if test '' != "$ADD_SIGNOFF"
766                 then
767                         echo "$ADD_SIGNOFF"
768                 fi
769             } >"$dotest/final-commit"
770             ;;
771         *)
772                 case "$resolved$interactive" in
773                 tt)
774                         # This is used only for interactive view option.
775                         git diff-index -p --cached HEAD -- >"$dotest/patch"
776                         ;;
777                 esac
778         esac
779
780         resume=
781         if test "$interactive" = t
782         then
783             test -t 0 ||
784             die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
785             action=again
786             while test "$action" = again
787             do
788                 gettextln "Commit Body is:"
789                 echo "--------------------------"
790                 cat "$dotest/final-commit"
791                 echo "--------------------------"
792                 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
793                 # in your translation. The program will only accept English
794                 # input at this point.
795                 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
796                 read reply
797                 case "$reply" in
798                 [yY]*) action=yes ;;
799                 [aA]*) action=yes interactive= ;;
800                 [nN]*) action=skip ;;
801                 [eE]*) git_editor "$dotest/final-commit"
802                        action=again ;;
803                 [vV]*) action=again
804                        git_pager "$dotest/patch" ;;
805                 *)     action=again ;;
806                 esac
807             done
808         else
809             action=yes
810         fi
811
812         if test $action = skip
813         then
814                 go_next
815                 continue
816         fi
817
818         if test -x "$GIT_DIR"/hooks/applypatch-msg
819         then
820                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
821                 stop_here $this
822         fi
823
824         if test -f "$dotest/final-commit"
825         then
826                 FIRSTLINE=$(sed 1q "$dotest/final-commit")
827         else
828                 FIRSTLINE=""
829         fi
830
831         say "$(eval_gettext "Applying: \$FIRSTLINE")"
832
833         case "$resolved" in
834         '')
835                 # When we are allowed to fall back to 3-way later, don't give
836                 # false errors during the initial attempt.
837                 squelch=
838                 if test "$threeway" = t
839                 then
840                         squelch='>/dev/null 2>&1 '
841                 fi
842                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
843                 apply_status=$?
844                 ;;
845         t)
846                 # Resolved means the user did all the hard work, and
847                 # we do not have to do any patch application.  Just
848                 # trust what the user has in the index file and the
849                 # working tree.
850                 resolved=
851                 git diff-index --quiet --cached HEAD -- && {
852                         gettextln "No changes - did you forget to use 'git add'?
853 If there is nothing left to stage, chances are that something else
854 already introduced the same changes; you might want to skip this patch."
855                         stop_here_user_resolve $this
856                 }
857                 unmerged=$(git ls-files -u)
858                 if test -n "$unmerged"
859                 then
860                         gettextln "You still have unmerged paths in your index
861 did you forget to use 'git add'?"
862                         stop_here_user_resolve $this
863                 fi
864                 apply_status=0
865                 git rerere
866                 ;;
867         esac
868
869         if test $apply_status != 0 && test "$threeway" = t
870         then
871                 if (fall_back_3way)
872                 then
873                     # Applying the patch to an earlier tree and merging the
874                     # result may have produced the same tree as ours.
875                     git diff-index --quiet --cached HEAD -- && {
876                         say "$(gettext "No changes -- Patch already applied.")"
877                         go_next
878                         continue
879                     }
880                     # clear apply_status -- we have successfully merged.
881                     apply_status=0
882                 fi
883         fi
884         if test $apply_status != 0
885         then
886                 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
887                 if test "$(git config --bool advice.amworkdir)" != false
888                 then
889                         eval_gettextln 'The copy of the patch that failed is found in:
890    $dotest/patch'
891                 fi
892                 stop_here_user_resolve $this
893         fi
894
895         if test -x "$GIT_DIR"/hooks/pre-applypatch
896         then
897                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
898         fi
899
900         tree=$(git write-tree) &&
901         commit=$(
902                 if test -n "$ignore_date"
903                 then
904                         GIT_AUTHOR_DATE=
905                 fi
906                 parent=$(git rev-parse --verify -q HEAD) ||
907                 say >&2 "$(gettext "applying to an empty history")"
908
909                 if test -n "$committer_date_is_author_date"
910                 then
911                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
912                         export GIT_COMMITTER_DATE
913                 fi &&
914                 git commit-tree ${parent:+-p} $parent ${gpg_sign_opt:+"$gpg_sign_opt"} $tree  \
915                         <"$dotest/final-commit"
916         ) &&
917         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
918         stop_here $this
919
920         if test -f "$dotest/original-commit"; then
921                 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
922         fi
923
924         if test -x "$GIT_DIR"/hooks/post-applypatch
925         then
926                 "$GIT_DIR"/hooks/post-applypatch
927         fi
928
929         go_next
930 done
931
932 if test -s "$dotest"/rewritten; then
933     git notes copy --for-rewrite=rebase < "$dotest"/rewritten
934     if test -x "$GIT_DIR"/hooks/post-rewrite; then
935         "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
936     fi
937 fi
938
939 # If am was called with --rebasing (from git-rebase--am), it's up to
940 # the caller to take care of housekeeping.
941 if ! test -f "$dotest/rebasing"
942 then
943         rm -fr "$dotest"
944         git gc --auto
945 fi